@echo off& setlocal enabledelayedexpansion

rem 11/13/2018 daydate.bat: Most recent version at paulhoule.com/daydate
rem Example of date manipulation within a .BAT file.
rem This is accomplished by first packing the date into a single number.
rem This demo .bat displays dates surrounding the current date, prefixed
rem with the day-of-week.

call :dgetl   y m d
call :dpack p y m d
set days=MonTueWedThuFriSatSun
for /l %%o in (-3,1,3) do (
  set /a o=p+%%o, o3=o%%7*3
  call :dunpk y m d o
  for %%d in (!o3!) do echo !days:~%%d,3! !y! !m! !d!
)
pause& exit /b


rem gets local date returning year month day as separate variables
rem in: %1 %2 %3=var names for returned year month day
:dgetl
setlocal& set "z="
for /f "skip=1" %%a in ('wmic os get localdatetime') do set z=!z!%%a
set /a y=%z:~0,4%, m=1%z:~4,2% %%100, d=1%z:~6,2% %%100
endlocal& set /a %1=%y%, %2=%m%, %3=%d%& exit /b


rem packs date (y,m,d) into count of days since 1/1/1 (0..n)
rem in: %1=return var name, %2 %3 %4= year month day (set/a expressions)
rem out: set %1= days since 1/1/1 (modulo 7 is weekday, Mon= 0)
:dpack
setlocal enabledelayedexpansion&^
set /a y=(%2)*512+(%3)*32+(%4), d=y%%32, m=y/32%%16, m3=m*3, y/=512&^
set t=xxx  0 31 59 90120151181212243273304334
set /a r=y-(12-m)/10, r=365*(y-1)+d+!t:~%m3%,3!+r/4-(r/100-r/400)-1
endlocal& set %1=%r%& exit /b


rem inverse of date packer
rem in: %1 %2 %3=var names for returned year month day
rem %4= packed date (set/a expression)
:dunpk
setlocal& set /a y=(%4)+366, y+=y/146097*3+(y%%146097-60)/36524,^
y+=y/1461*3+(y%%1461-60)/365, d=y%%366+1, y/=366
set m=1& for %%x in (31 60 91 121 152 182 213 244 274 305 335
) do if %d% gtr %%x set /a m+=1, d=%d%-%%x
endlocal& set /a %1=%y%, %2=%m%, %3=%d%& exit /b
